----------------------------------------------------------------------
Version 1.12.1, by Aleksey Cheusov, Sun, 22 Jul 2012 16:33:39 +0300

  dictl.in:
    Fix for Debian bug #677868 reported by Stepan Golosunov.

  dictd.8:
    Fixes for mistypes found by A. Costa. Thanks!

  dictzip:
    Fix for sf.net bug #3390567 reported by Ivo Danihelka.

  INSTALL:
    Fix for sf.net bug #3398178

  colorit:
    Fix for option -c. Now it works correctly.

  examples/dictd_virtual.conf:
    Fix incorrect keyword for virtual database.
      Thanks to Marc-Jano Knopp for the report!

----------------------------------------------------------------------
Version 1.12, by Aleksey Cheusov, Sun,  9 Jan 2011 18:16:34 +0200

  New script dict_lookup for translating words and phrases from X
  selection. It makes sense to configure launching dict_lookup on a
  keyboard shortcut in the window manager.

  dictd: Fix for SHOW SERVER command (dict -I).  On systems where
  sizeof(int) != sizeof (long) values in "Uncompressed" column may
  contain random garbage.  This problem was seen on NetBSD/x86_64/5.1

  Fix for sf bug #3098788
  https://sf.net/tracker/?func=detail&aid=3098788&group_id=605&atid=100605
  Regresson tests for dictzip were added.

  Fix in Makefile: non standard option for lex(1) was removed
  (This may unbreak compilation on SunOS, HP-UX...).

  dictfmt:
  Internal buffer size was increased from 10240 to 102400 bytes.

  Fixes for Tru64.

  Other minor fixes and cleanups

----------------------------------------------------------------------
Version 1.11.2, by Aleksey Cheusov, Sun,  4 Oct 2009 10:55:28 +0300

  FIX: When search is handled by dict_search_bmh() function, the first
  character from the first entry in the index file is missing. Usually
  this is some of 00-database-* entries.  Thanks to Goran Tal for a
  bug report and patch.

  fix in dictfmt.1: s/--index-keep-headword/--index-keep-orig/

  dictfmt: superfluous spaces are removed not only from the beginng
  and the end of a headword but also inside a multiword headwords.
  Thank to Goran Tal for pointing out.

  dictfmt spawns sort command to sort the index. When there are
  several entries for the same headword, they get sorted BY OFFSET AND
  SIZE (in addition to headwords). As a result, the order of identical
  headwords is messed up.  To fix these problem -k1,3 option is
  replaced with -k1,1.  Thanks to Goran Tal for pointing out.  With
  -k1,1 options not all flavours of sort(1) command keeps an original
  headword order but now you a have chance.

  Regression tests updated.

----------------------------------------------------------------------
Version 1.11.1, by Aleksey Cheusov, Fri, 27 Feb 2009 22:16:49 +0200

  FIXES:

     Minor fix in dictd.8 (paths to config files), sf.net bug #2407717
     Thanks to Peter Volkov

     Bug fixed in installing plugins, sf.net bug #2218879,
     Thanks to Peter Volkov

     DICTFMT sorts entries in 00-database-alphabet entry
     lexicographically, that is now this order doesn't depend on
     sizeof(long). This fixes sf.net bug #2197588.
     Thanks to Peter Volkov and his tests on PowerPC.

     DICTD: SHOW STRAT: s/databases present/strategies present/
     found and reported by Goran Tal <goran.tal@gmail.com>. Thanks.

     DICTFMT: 'dictfmt -I' never worked (regrettable oversight, heh),
     found and reported by Goran Tal <goran.tal@gmail.com>. Thanks.

  Makefile.in, configure.in:
  "building and installing different set of things based
  on configure results considered harmful"(C) me :-)
  Plugins support in dictd is enabled by default (if available).
  DBI and JUDY plugins are disabled by default.
  Enable them explicitly by using
    ./configure --with-plugin-dbi
  and
    ./configure --with-plugin-judy
  This fixes sf.net bug #2218879 by Peter Volkov.

  By using DICTL_USE environment variable dictl utility can now use an
  external program for charset2charset conversions. This addresses
  sf.net bug #2407725, again by Peter Volkov

  * Makefile.in, configure.in:
  (Clean-ups)
  --with-local-libmaa option is removed from "configure" script.
  You should build libmaa manually before dictd/dict/...
  This removes lots of garbage from configure.in and Makefile.in and
  makes them MUCH cleaner. If you want to link dictd with libmaa statically,
  use Makefile's LIBMAA variable.

  configure.in, include_regex.h.in, index.c:
  (Clean-ups) Ages ago, I've add to "configure" script an option
  --with-regex-include to make possible to build dictd with PCRE.
  Now, I've removed this option. If you want to build dictd with with PCRE,
  ask PCRE developers to install pcre/regex.h file linked to pcreposix.h.
  All other regexp libraries compatible with POSIX API do the same,
  rx/regex.h, rxspencer/regex.h etc. etc.
  So, this is good and well known convension.

  Makefile.in: LIBMAA variable added. Change it if you want to link
  dictd against libmaa statically or...

  * configure.in: Enable additional gcc warnings on all platforms
  unconditionally, not only under Linux, I need them under NetBSD.

  Makefile.in: fix for "uninstall" target

  Lots of clean-ups in dictl.

  Other minor clean-ups in Makefile.in and configure.in

  Minor spelling fixes in NEWS

----------------------------------------------------------------------
Version 1.11.0, by Aleksey Cheusov, Sun,  7 Dec 2008 23:05:21 +0200

  dictd tarball no longer contains libmaa library.  Now
  dictd/dict/dictfmt/dictzip/... are built with external libmaa
  library. Also, by default local "libmaa" directory is not used to
  detect libmaa even if this directory is present,
  use './configure --with-local-libmaa' option to force this.

  configure:
    removed: --with-cc, --with-cflags, --with-prog, --with-gprof,
    --with-checker, --with-efence, --with-insure and --with-purify
    options. Use standard CC, CPPFLAGS, CFLAGS, LDFLAGS etc.
     environment variables instead

  Compilation errors fixed on Solaris, Interix, HP-UX and others.

  dictfmt_index2suffix: \001 -> \1 inside regexp. It seems it is better
  eccepted by different awk/regexp_engines. (heirloom posix2001/awk and
  libuxre)

  fixed: sf.net bug #1627458 (make samples fails to build)

  fixed: sf.net bug #1941358 (first connection is denied)

  dictfmt_index2suffix: no need for GNU awk

  dictfmt_index2suffix and dictfmt_index2word are generated from *.in

  Lots of minor fixes and clean-ups in regression tests, Makefiles,
  configure...

  Lots of GCC warning messages were also fixed

----------------------------------------------------------------------
Version 1.10.11, by Aleksey Cheusov, Mon,  7 Apr 2008 00:28:10 +0300

 Everything can now be compiled with pcc (Portable C Compiler),
 tested under NetBSD

 clean-ups in C code, configure.in etc.  Warning messages generated by
 NetBSD/alpha were fixed.  Lots of warning messages produced by icc-10
 (Intel C Compiler) were fixed too.

 FIX: now dictd/libmaa can be built from external "object" (any!)
      directory just like many other autobloat-based projects can do.

      That is, the following works fine now

        cd obj-dir
        /path/to/dictd-sources --with-libmaa
        gmake
        gmake install

 dictd:
     - FIXED: compilation failure on Linux if --disable-plugin
       option is specified.
     - index.c:
       FIXED: while processing MATCH command unicity of only first
       column of .index is checked, but fourth column (if present)
       is not.

     - timestamp log marker (log_option "timestamp") is changed from
       :T: to :t: because :T: begins client's full command (log_option
       "command")

 dictfmt:
     - FIXED: maximum length of headwords is limited to hardcoded
       constant just by cutting the end of headword.  Now internal
       arrays are realloced automatically.

 dict:
     - ADDED: -F|--flush option for flushing stdout after each
       definition/match. This may be useful in combination with -f

 colorit:
     - bashism fixed: 'echo -en' -> more portable 'printf'.
       Thanks to Debian users.

 libmaa:
     - fixed: DESTDIR support

 dictdplugin_popen:

     - fixed: missed header file, seen with gcc-4.3.
       Thanks to Martin Michlmayr for report

----------------------------------------------------------------------
Version 1.10.10, by Aleksey Cheusov, Sat, 10 Nov 2007 22:03:06 +0200

 dict, dictl, colorit:

    - all these programs do NOT support paging to a special program, i.e.
      --pager|-P option.
      As of this version everything is output to stdout only.
      Now, 'dict' program for dictionary protocol is like wget for http.

      Sorry for breaking backward compatibility but this change makes
      the code cleaner, smaller and more manageable.

      If you run 'dict' (or 'dictl') interactively, write the following
      to your interactive shell startup script (.ksh, .zsh, .bashrc etc.)

            mydict () { dict "$@" 2>&1 | colorit | less; }

      and then use 'mydict' instead of 'dict' (or 'dictl')


      '-P -' option is allowed.

 dictd:

    - added support for utf-8 symbols other than BMP

 other minor fixes and cleanups

----------------------------------------------------------------------
Version 1.10.9, by Aleksey Cheusov, Tue, 29 May 2007 23:20:14 +0300

 dictd:
    - ADDED: 'limit_time' keyword for limiting time (in seconds)
      during which a client may talk to the server.
      This is for preventing DOS attacks.
      This option may be used as a replacement for 'delay' option.
      See dictd.8 for the documnetation

    - ADDED: new keyword 'limit_matches' and 'limit_defintions'
      limiting a number of matches and definitions respectively
      that the server may send to the client.
      This is for preventing DOS attacks.
      See dictd.8 for more information

    - ADDED: new keyword 'limit_queries'
      limiting a number of queries that client may send to the server
      This is for preventing DOS attacks.
      See dictd.8 for more information

    - ADDED: new keyword 'limit_childs' equal to old 'limit'.
      'limit' is now deprecated. Use 'limit_childs' instead.

    - ADDED: Two new search strategies, 'first' and 'last'.
      They match first or last word only in a multi-word entries.
      See dictd.8 for more information.

    - ADDED: new keywords 'site_no_banner', 'site_no_uptime'
      and 'site_no_dblist' for changing the way dictd answers on SHOW SERVER
      command (dict -I)
      See dictd.8 for more information.

    - ADDED: support for the case-sensitive search.
      For this database should be created with dictfmt --case-sensitive.

    - 'site' keyword has been moved to 'global' section of dictd.conf file
      Do not place it at the top level!

    - removed: --test-XXX options. Use -i and --stdin2stdout for debugging.

 dictfmt:
    - FIXED: longopts passed to getopt_long as argument was not
      ended with zeros. I even don't how this code could work
      for so many years.
      Affected dictfmt versions: 1.6.1-1.10.8

    - ADDED: --index-data-separator option that allows
      to set index and data parts of the headword in .index file
      (first and fourth columns respectively) completely independantly.

      That is, the first column in .index file can now be treated
      as an index and an optional fourth columns - as a data, all this for
      MATCH protocol command. See dictfmt.1 for more information.

    - added: -i and -I for resorting .index files.
      See dictd.8 for more information.

    - added: By default a special headword 00-database-dictfmt-X.Y.Z
      is generated, i.e. every created database is marked
      "what version of dictfmt was used to create it".
      added: --without-ver option for preventing this.

 dictunformat:
    - minor fixes and improvements for 4-column .index file input
       See dictfmt --index-data-separator and
           dictunformat --index-data-separator

 dictfmt_index2suffix and dictfmt_index2word
    - fixes, now these utilities are ready for 4-column input and
      use 'dictfmt -i/-I' for resorting .index entries.
      See dictfmt.1 for more information.

 dict:
    - ADDED: -f option that enables formatted output, i.e. output 
      convenient for postprocessing by standard UNIX utilities.
      See dict.1 for more information.

----------------------------------------------------------------------
Version 1.10.8, by Aleksey Cheusov, Wed, 13 Dec 2006 22:20:04 +0200

 libtool is now used for building dictd and libmaa.
    This makes them more portable, especially
    libmaa with the shared object files support.

 dictd:
    - fixed: sourceforge.net bug #1554437 ('nprefix' strategy)
    - added: --stdin2stdout option for debugging purposes.
      See dictd(8)
    - fixed: daemon3.c on Solaris

 Minor selftests improvements.

 ./configure.in|Makefile.in:
    - WCFLAGS, XTRACFLAGS, WLDFLAGS, XTRALDFLAGS,
      LDSHARED, XTRAHEADERS variables are no longer used.
      For configuring dictd use CPPFLAGS, CFLAGS
      and LDFLAGS variables only.
    - fixed: finding lex and yacc (fails on NetBSD).
    - --without-local-libmaa is the default now

 Makefile.in:
    - fixed: install target on Solaris
      (Solaris install != BSD install)

----------------------------------------------------------------------
Version 1.10.7, by Aleksey Cheusov, Sun, 16 Jul 2006 21:36:49 +0300
 DICTD:
    - FIXED: pidof(dictd) != `cat /var/run/dictd.log` because writing
      a pid is made before call of daemon(3) that runs fork(2).

      Affected versions: 1.10.6

    - FIXED: nmap utility or just a client that aborts connection
     for any reason can cause dictd server to exit with error
     on NetBSD-3.0 and probably other OSes. This happens because
     accept(2) returns ECONNABORTED error code allowed by SUSv3,
     but this error code is treated as a critical error code by dictd.
     Linux seems not affected.

      Affected versions: ALL, i.e 1.4.9-1.10.6

----------------------------------------------------------------------
Version 1.10.6, by Aleksey Cheusov, Tue,  4 Jul 2006 01:17:53 +0300

 DICTD:
    - FIXED: 'word' strategy works incorrectly with UTF-8
      on non-glibc systems, i.e. BSD, Solaris and probably others.
    - new selftest added
    - if opening a pid file or log file failed,
      error messages are printed to stderr, older versions did not
      generate error messages at all in this case.

 DICTFMT:
    - --index-keep-orig option is added to dictfmt.

      When --utf-8 option is applied, headwords are lowercased and
      non-alphanumeric characters are removed from it
      before writing them to .index file
      in order to simplify the search.
      With --index-keep-headword option
      the fourth column is created (if necessary) in .index file,
      and contains the original headword which is returned by MATCH command.
      This option may be useful to prevent converting "AT&T" to "att"
      or to keep German nouns with uppercased first letter.

 LIBMAA:
    - added: new function b64_decode_buf
    - FIXED: sf.net bug #1463396 in hash.c

----------------------------------------------------------------------
Version 1.10.5, by Aleksey Cheusov, Fri, 26 May 2006 23:12:49 +0300

 DICTD:
   - FIXED: In case database_exit directive is used in dictd.conf
     SHOW DB command returns incorrect number of databases available.

     Afected versions: 1.10.2 -- 1.10.4

   - As of dictd-1.9.14 dictd creates log file being root and then
     releases root priviledges. This was my bad idea because log file
     may have % sign and may be used as a **pattern for log files**.

     NOW OLDER BEHAVIOUR IS RESTORED, i.e.
     log file is created after releasing root priviledges.
     If you want to create log file under /var/log directory, create
     /var/log/dictd with appropriate permissions and create log files there.

     I apologize for inconvenience and breaking backward compatibility.

----------------------------------------------------------------------
Version 1.10.4, by Aleksey Cheusov, Mon, 12 Dec 2005 20:36:32 +0200

 DICTD

  FIXED: pid file was created with 0666 permissions.
    Affected dictd versions: 1.10.1 - 1.10.3

----------------------------------------------------------------------
Version 1.10.3, by Aleksey Cheusov, Thu,  8 Dec 2005 20:54:23 +0200

 REGEX/ZLIB libraries have been removed from dictd CVS tree.
    Most UNIX-like OS'es and distributions have these libraries
    in a prebuilt form. Otherwise, build and install them yourself.

 MAKE TEST:
    - lots of new tests for 'dictd'.
    - fixes, code clean-ups and improvements of tests for 'dictfmt'

 DICTD/DICT/DICTFMT/DICTZIP
    config.sub and config.guess have been updated (GNU/kFreeBSD)

 DICTD
    -ADDED: new search strategy `nprefix'.

       dictd.8:
       ...
       nprefix

         Like prefix but returns the specified range of matches. For
         example, when prefix strategy returns 1000 matches, you can
         get only 100 ones skipping the first 800 matches.  This is
         made by specified these limits in a query like this:
         800#100#app, where 800 is skip count, 100 is a number of
         matches you want to get and "app" is your query.  This
         strategy allows to implement DICT client with fast
         autocompletion (although it is not trivial) just like many
         standalone dictionary programs do.

         NOTE: If you access the dictionary "*" (or virtual one) with
         nprefix strategy, the same range is set for each database in
         it, but globally for all matches found in all databases.

         NOTE: In case you access non-english dictionary the returned
         matches may be (and mostly will be) NOT ordered in alphabetic
         order.

    -fixed: setenv.c (Solaris)
    -fixed: compilation bug under Solaris (decl.h)
    -fixed: strange segfault in log_info function under Interix 3.5
            (4096-byte array on stack + va_XXX calls)
    -FIXED: buffer overflow (segfault) in log_{error,info} functions.
            This may happen when dictd is run with -L option
            and it definitely segfaults on condition that:
            - -dinit option is enabled;

            - Japanese of Chinese dictionary created by dictfmt-1.9.14
              (or later) is in dictd.conf
            - -L

            This happens due to too long 00-database-alphabet "definition"

            Affected versions: all?

 DICTL
    -fixed: sf.net bugs #1223489 and #1227624, patches by micha137

 DICT
    -minor fixes with pager, patches by Kirk Hilliard
    -fixed: assert(3)
           Affected dict calls:
             dict -M -S
             dict -M -D
             dict -M <query>

 LIBMAA
    -fixed: compilation bug (alloca)

 Documentation:
    - Samples configuration files for 'dictd' and 'dict' have been moved
      to samples/ subdirectory.
    - File names directories in manual pages
      are specified according to ./configure options
    - A few references to samples/ are added to dictd.8.
      I hope this will make dictd.8 a bit simplier for new users.
    - minor fixes and improvents

 removed: dictfmt_virtual, dictfmt_plugin utilities.
 The only way to configure plugin or virtual databases
 is by using dictd.conf file.
 I hope nobody used these utilities.
 Otherwise, sorry for inconvenience.

----------------------------------------------------------------------
Version 1.10.2, by Aleksey Cheusov, Tue,  6 Sep 2005 20:31:29 +0300

 I started to create selftests for dict project.
 There are a few tests yet.
 Run 'make test' on your platform and notify me if
 some errors happend.

 FIXES:

    - fixed: compilation bugs on FreeBSD4, Solaris and MacOS-X
      Affected versions: 1.10.1

    dictd:
    - because of optimization code and strange binary search
      the 'regexp' strategy may work incorrectly

      Thanks to Slava Kravchenko for bug report.
      Affected versions: 1.4.9(?) - 1.10.1

    - 'SHOW DB' command shows the special entry '--exit--'
      as a normal database which cannot be used for searching.
      This contradicts rfc-2229.
      To see when the default search stops, use 'SHOW SERVER' command
      instead.

    dictfmt:
    - because not only index part of .index file was used for sorting
      bu 'sort' utility, 'dictfmt' may create incorrect index file.
      Now sort is run with '-t <tab> -k 1,3' options.
      Affected dictfmt versions: 1.6.1-1.10.1
      It is recommended to rebuild existing databases.

    - because 'sort' utility inherits LANG and LC_... variables
      from 'dictfmt', incorrect .index files may be created if
      you run dictfmt with non_C locale even if you create ascii (non-utf8)
      database. To fix this LC_ALL environment variable is always set to C
      before running 'sort'.
      It is recommended to rebuild existing databases.

----------------------------------------------------------------------
Version 1.10.1, by Aleksey Cheusov, Thu,  9 Jun 2005 20:03:22 +0300

 fixes:
    - compilation bugs on sparc64/{Free,Open,Net}BSD has been fixed
     Thanks to koresh for bug report and patch.

 dictd/dictfmt:
    - By default, local implementations of UCS-2/UTF-8 functions
      are used. As a result 'dictd' run
      with no option works in UTF-8 mode,
      but ASCII one. The option '--locale xx_YY.UTF-8'
      is no more requied for both dictd and dictfmt.
      In contrast with 'dictd', 'dictfmt' is run in ASCII mode
      by default. In order to create utf-8 dictionary,
      run 'dictfmt' with --utf8 option.
      Thus both 'dictd' and 'dictfmt' should work the same way
      on all platforms even if it doesn't provide necessary functions
      or UTF-8 locale. Tested on MS Interix 3.5.
      If you dislike this feature, ./configure dict with
      --with-system-utf8-funcs option.

 dictd:
    - By default dictd, when running as daemon, writes a PID
      to /var/run/dictd.pid file. This can be overriden by
      'pid_file' keyword in dictd.conf (See dictd.8) or command line
      option '--pid-file'.
      Thanks to Josef Novak for sudgestion and patch.

 documentation:
    - fixed: dictd.8 says that 'lev' strategy doesn't work
      with UTF-8 dictionaries, but it does since release 1.9.13

----------------------------------------------------------------------
Version 1.10.0, by Aleksey Cheusov, Tue, 12 Apr 2005 20:51:01 +0300

  dictd:
    - Most parameters can be passed to `dictd' via configuration file.
      See 'Global Setting section'
      in dictd.8 for more information.

      Also see example.conf for the sample config.

    - Added: ability to create special databases that work
      differently depending on
      whether client sent OPTION MIME command or not.
      This allows to provide dictionaries returning either plain text or
      specially formatted (html, roff, TEI etc...) definitions depending on
      client's capabilities or needs.

      See example_mime.conf file for example and dictd.8 for documentation.

    - fixed: `default_strategy' keyword was not implemented
      for `database_plugin' section.

    - fixed: compilation bugs on OpenBSD-3.4 which doesn't provide
      CODESET macro in <langinfo.h>

  dict:
    - added: -M option for sending OPTION MIME command to DICT server.
      NOTE: client doesn't check whether DICT server supports MIME or not)

  dictfmt:
    - added option `--mime-header <mime_header>'.
      When database is accessed by client and OPTION MIME command
      was previously sent, definitions are prepanded by the specified
      MIME header. Ability to set the MIME header for the database is
      useful in combination with `database_mime' keyword in dictd.conf,
      See dictd.8 for more information.

----------------------------------------------------------------------
Version 1.9.15, by Aleksey Cheusov, Thu, 23 Dec 2004 21:16:03 +0200

  Format of .index files for 8-bit databases (not-ASCII and non-UTF8)
  has been changed. This makes `dictd' backward incompatible with
  8-bit dagabases built by earlier versions of `dictfmt', i.e.
  `dictd-1.9.15' and later doesn't work with 8-bit databases
  generated by dictfmt-1.9.14 and earlier. See ChangeLog for details.
  If you use 8-bit database, rebuild them using new `dictfmt' like this
  dictunformat db.index < db.dict | dictfmt -t --locale <locale> db-new

  dictd:
    - fixed: Function `dict_search_bmh' works incorrectly in utf-8 mode
        on non-GLIBC systems.
        As a result `suffix', `substring' and `word' strategies
        may work incorrectly with UTF-8 databases
        on such platforms (FreeBSD).

    - fixed: In dictd-1.9.8 support of CYGWIN was declared,
             but it was broken in later versions.
             dictd-1.9.15 can be succesfully built with CYGWIN.

    - fixed: `dictd' dies when client tries to obtain information
             about virtual database (SHOW INFO <virt_db>).

    - Every database specified in configuration file
        may have its own "default" search
        strategy (i.e. `.' strategy).
        For this purpose additional
        keyword `default_strategy' is implemented.
        See example2.conf sample file and dictd.8 for documentation.

    - When `-d' is applied,
        debugging information is printed to syslog (or log file or stderr).

        NOTE: `-dinit' option may show you a reason why dictd doesn't start.
              If you are in trouble, apply it first (and -L or -s of course)!

    - dictd works correctly even on platforms which do not provide
        `iswalnum', `iswspace' and `towlower' functions.
        Dictd with utf-8 databases was slightly tested on FreeBSD4.{9,10}

    -fixed: logging is directed to stderr when --inetd is applied

    - `AC_FUNC_MMAP' is replaced for `AC_CHECK_FUNC(mmap)' in configure.in
      As a result `mmap/munmap' functions will be used on CYGWIN and INTERIX
      if they are present.
      If you dislike it, use --without-mmap option.

  dictdplugin_dbi plugin:
    - new options: `all_char' and `utf8'.
      `all_char' option is set to FALSE by default.
      `utf8' option is set to TRUE by default.
      Both are overrided by
      `00-database-allchars' and `00-database-utf8' special headwords.

  dictd/dict/... have been ported to Interix (MS SFU-3.0 and SFU-3.5).
       It works fine as Interix daemon
       with ASCII databases (tested on Interix 3.0 and 3.5)

       NOTE: GNU make is needed for building `dictd'

  dictfmt:
    - new option --default-strategy. See dictfmt(1).

  Documentation update

----------------------------------------------------------------------
Version 1.9.14, by Aleksey Cheusov, Sun,  6 Jun 2004 21:18:19 +0300

  dictd:
    - fixed: SHOW INFO command sends incorrectly formatted data
      to the client if
      the information about database was set using 'info' keyword.
      Affected versions: 1.9.12-1.9.13

    - 'dictd' opens a log file (-L option) before releasing root priviledges.
      As a result log file can be created in /var/log directory.
      Log file and syslog are opened once.

      Error messages of sanity checks are written to log file (or syslog)
      but the stderr.

    - --listen-to <ip> option binds a socket to the specified address.
      See dictd.8 for details.

    - SIGUSR1  causes  dictd  to unload databases.
      Then dictd returns 420 status (instead of 220).
      See dictd.8 for details

    - exit status of child processes is written to log
      if '--log server' is specified.

  dictfmt:
    - fixed: 'dictfmt --locale <8bit-locale>' works incorrectly
      and may assert(3) on platforms
      having no 'mbrlen' function (FreeBSD-4).
      Affected versions: 1.9.12-1.9.13

    - -t option implies '--columns 0' to preserve original formatting

    - Special 00-database-XXX headwords do not affect 00-database-alphabet,
      i.e. only characters from "real" headwords
      are added to alphabet.
      This makes LEV search strategy a little faster,
      especially search in dictionaries
      containing non-Latin symbols only, for example, Cyrillic symbols.

  dict:
    - In case of error 'dict' exits with non-zero status.
      See Section EXIT STATUS in dict.1 for details.

  libmaa:
    - arg_argify function has been reimplemented because it is buggy.
      Affected 'dictd' versions: 1.4.9-1.9.13.
      More tests for arg_argify function have been added
      Testing program has also been reimplemeneted.
      See ChangeLog for details.

----------------------------------------------------------------------
Version 1.9.13, by Aleksey Cheusov, 24 Mar 2004 11:32:53 +0200

  FIXED: if database has no 00-database-alphabet headword,
      "global" alphabet is built incorrectly. As a result
      dictd may work (FreeBSD does) incorrectly with LEV strategy.
      Affected versions: 1.9.12

  ADDED: plugin using libdbi library for implementing DICT database using
    SQL server. It is possible to specify custom search strategies
    by specifying SQL query.

    The following option are currently supported:

      driverdir       - path to DBI drivers
      drivername      - DBI driver name, such as pgsql, mysql, sqlite etc.
      option_host     - host to connect to
      option_port     - port to connect to
      option_dbname   - database name
      option_username - user name for authorizing to SQL server
      option_password - user password for authorizing to SQL server
      query_define    -        SQL query for implementing DEFINE command
      query_<strategy> - SQL query for implementing
           'strategy' (MATCH command).
           Note that 'strategy' is not limited to the "standard" ones.

    See the file example_plugin_dbi.conf for sample of how
      this plugin can be configured.

    SQL queries should return 1-column result by using SELECT command.
      %q sequence inside SQL query is expanded to user's query.
      %% is expanded to single % sign.

    This plugin gives a simplest way to implement editable
      dictionaries with a help
      of WEB interface, but with a read-only access to it
      using DICT protocol.

    NOTE! Unless libdbi library is not found on your system
    or you configure dictd with --disable-plugin option,
    'dictd' is linked with libdbi to resolve DBI driver's symbols.
    This should be fixed.

    NOTE! Connection to SQL database is made
    for every DEFINE/MATCH command.
    This slows down plugin and should be fixed.

----------------------------------------------------------------------
Version 1.9.12, by Aleksey Cheusov, 10 Mar 2004 18:45:15 +0200

  Both dictd and Judy-plugin correctly implement
    the 'lev' strategy for utf-8 databases.
    For this purpose an additional headword 00-database-alphabet is
    created by dictfmt.
    So, if you often use 'lev' strategy with utf-8 dictionaries,
    rebuild them using dictfmt-1.9.12

  'nl_langinfo' function is used to detect
      whether dictd/dictfmt uses 8bit, utf-8, or C locale.

  dictd:
    - fixes

       SHOW SERVER command cuts off long database names

       crash on Solaris (and FreeBSD5 ?) due to
         toupper('255') returns 376 if utf-8 locale is set.

       LC_CTYPE and LC_COLLATE are set according to --locale.
         As a result date and time are logged using the C locale

    - MATCH|DEFINE *|! ignore invisible dictionaries.
         Now there is no reason to separate visible and invisible dictionaries
         by database_exit command.
         This simplifies the configuration file.

    - dictd --test|--test-file notifies about invalid database name

  dictl:

    - checks whether recode/iconv/konwert/locale commands are available

    - analyses PAGER variable to set a pager.

    - incorrect charset determination has been fixed

  dictfmt:

     - new option --break-headwords for use with --headword-separator, so
       each headword is written on its own line of the .dict file.

     - correctly wraps utf-8 input

     - new option --columns to set a number of columns for
      wrapping text. See dictfmt.1. By default this value is 72.
      All formats are affected and use the same default.

     - 00-database-XXX headwords are not copied to .dict file.
         The only exception is 00-database-short which should be copied
         to .dict file for older 'dictd'

  maa:
      new functions and #defines:
         'str_pool_init_position', 'str_pool_next_position',
         'str_pool_get_position', 'str_pool_readonly', 'str_pool_iterate',
         'str_pool_iterate_arg', 'STR_ITERATE' and 'STR_ITERATE_END'
         to iterate over strings in the string pool.

      fixed a bug in flags.c/flg_set function

  dictdplugin_judy:
      
      fixed: if a requested headword has more than one definition,
         DEFINE command always returns the first one

----------------------------------------------------------------------
Version 1.9.11, by Aleksey Cheusov, 8 Dec 2003 20:55:31 +0200

  NEWS file added

  dictd:
    - dictd is compiled successfully on Solaris, MacOS-X(cc).
      A lot of warning and error messages appeared
      on 64-bit Opteron and Alpha were fixed.

    - fixed: 'suffix' strategy doesn't ignore characters other than
       alphanumeric and spaces. Affected versions: 1.9.1-1.9.10
    - A multi-lined short name of the database is truncated before sending
      to the client

    - patch by Michael Bunk <bunk at imn.htwk-leipzig.de} fixing:
       - a typo giving the incomprehensible failure message.
         Affected versions: 1.7.1-1.9.10

       - a typo resulting in 'dict --server-info' showing
           same compressed/uncompressed database sizes
         Affected versions: 1.9.1-1.9.10

       - broken AUTH command.
         Affected versions: 1.9.4-1.9.10

    - added: keyword "disable_strategy for disabling a specified strategy
             for a particular database.
             Strategies disabled by 'disable_strategy' keyword
             are not passed to plugins.

    - info/name keywords in 'database_virtual' section can handle
      entry name beginning with @ symbol in a similar way
      as 'database' and 'database_plugin' do.

    - dictd --pp <prog> sets a preprocessor for configuration file.

      If you run DICT server having a lot of dictionaries, you can preprocess
      configuration file using m4 (or cpp). This significantly reduces
      the size of configuration file.

      See dictd.8 and example_complex.conf.

  plugins:
    - the default directory for databases
      is passed to plugins (DICT_PLUGIN_INITDATA_DEFDBDIR)

    - plugin support is ported to systems having dlXXX API in libc (FreeBSD).

    - added: Judy-based plugin implementing fast "exact" and especially "lev"
      strategies. http://sf.net/projects/judy

      See example_complex.conf for the sample of usage.

      "prefix" strategy is also supported but
      for short queries it may be very slow. If you need not this,
      disable it by "disable_strategy" keyword.


  dict:
    - clientparse.y will accept "pager' as the pager.
      Thanks to Kirk Hilliard.

  dictfmt:
    - fixed: dictfmt -f doesn't work correctly if the first two lines are empty
      Affected versions of dictfmt:  1.6.1-1.9.10
    - fixed: --headword-separator doesn't work with -f, -p and -v formats

  dictl - wrapper script for "dict" that permits using utf-8 encoded
       dictionaries on a terminal that is not utf-8 aware.
       See dictl.1 for documentation.

  colorit - a script for colorizing the text input which can be used
       as dict pager. It is currently very simple but allows to make
       dict's output a bit nicer.
       See colorit.1 for documentation.

  documentation update

  other fixes and improvements

----------------------------------------------------------------------
Version 1.9.10, by Aleksey Cheusov, 22 Jul 2003 19:37:22 +0300

  dictd-1.9.10 has been released.
  It is available for download from
  http://sf.net/projects/dict


  Major changes:
  - 'filter' option is fully implemented

  - Documentation update

  - fixes:
  - 'lev' strategy (pple' query doesn't match the word 'apple')
  Affected version: 1.4.9 - 1.9.9

  - 're' and 'regex' strategies
  ('^apple|orange' and '^apple\|orange' doesn't match a word 'orange')
  Affected versions: 1.4.9-1.9.9

  - incorrect spaces trimming
  Affected versions: 1.9.1-1.9.9

  - 'dictd' can be built with a regex engines
  other than local Henry Spencer's one.
  A system-wide regexec/regcomp are used by default.
  The first reason for this is that Henry Spencer's' implementation
  is not a fastest one. The second reason is that it doesn't support utf-8.

  - added: dictfmt -t. This simplifies rebuilding
  databases using 'dictunformat' utility.

  - System-wide wcXXX and mbXXX functions are used if present.

  - predefined DICT servers dict.org and alt0.dict.org 
  are not used by default by 'dict' client

----------------------------------------------------------------------
Version 1.9.9, by Aleksey Cheusov, 14 Apr 2003 19:30:54 +0300

  dictd-1.9.9 has been released and it is available for download from
  http://sf.net/projects/dict

  Major changes:
  - dictd can be run from inetd.

  - cygwin improvements

  - dlopen is used instead of lt_dlopen on platforms where it is
  available (concerns to plugins)

  - bug fixes

----------------------------------------------------------------------
Version 1.9.8, by Aleksey Cheusov, 27 Mar 2003 15:33:34 +0200

  dictd-1.9.8 has been released and is available for download from
  http://sf.net/projects/dict

  Major changes:
  - dictd can be compiled on CYGWIN without utf-8 support.
  If anyone manages to run dictd on Windows as a service, let me know.

  - UTF-8 support is optional. It is disabled on platforms which don't
  support 'iswalnum', 'iswspace' or 'towlower' functions.

  - fixes:
  - 'dictdb_free' plugin function is not called
  (affected versions: 1.9.1-1.9.7)
  - incorrect dzip format detection
  (affected versions: 1.4.9-1.9.7 (all?))
  - possible crash while reading too long COMMENT or FNAME fields of
  the dzip'ed file (dictzip doesn't create them)
  (affected versions: 1.4.9-1.9.7 (all?))

----------------------------------------------------------------------
Version 1.9.7, by Aleksey Cheusov, 09 Mar 2003 20:03:42 +0200

  dictd-1.9.7 is released

  Download it from http://sourceforge.net/projects/dict.

  Major changes:

  - 'database_virtual' keyword in the configuration file
  specifies 'virtual' dictionary without database files.

  - 'database_plugin' keyword in the configuration file
  specifies plugin without database files.

  - 'info' keyword in the 'database specification'
  specifies the information about database. @ prefix is also supported
  and specifies an entry name.

  - dictd --add-strategy
  allows to implement (with a help of plugins)
  new strategies not available in 'dictd'.
  For example, 'revert' strategy may be implemented.
  By using '--with-strategy' and '--add-strategy' options
  it is possible to create DICT server with the set of strategies
  you need.

  - 'invisible' keyword in the configuration file
  allows to hide several databases.
  This may be useful if you use virtual databases.

  - 'string' in the configuration file can be continued between lines.

  - ./configure --with-nec-socks5
  With this option applied, programs will be linked with
  the NEC socks5 library

----------------------------------------------------------------------
Version 1.9.6, by Aleksey Cheusov, 02 Mar 2003 14:19:37 +0200

  A bug fixing release is available for download
  from http://sf.net/projects/dict

  Changes:

  critical fix: dictd may crash on BMH search
  (substring, suffix and word strategies) because
  it accesses memory outside mmap'ed region.

  Affected versions: 1.4.9-1.9.5

----------------------------------------------------------------------
Version 1.9.5, by Aleksey Cheusov, 23 Feb 2003 20:28:32 +0200

  If the 'name' keyword is used in database section, and
  it doesn't begin with '@', dictd may crash on SIGHUP.
  Affected versions: 1.9.1-1.9.4.

  The following is the patch. This patch is the only difference between
  dictd-1.9.4 and dictd-1.9.5 releases.


  You can download dictd-1.9.5 from http://sf.net/projects/dict


  diff -ruN dictd-1.9.4/dictd.c dictd1/dictd.c 
  --- dictd-1.9.4/dictd.c Mon Feb 10 21:24:25 2003 
  +++ dictd1/dictd.c      Sun Feb 23 19:13:43 2003 
  @@ -572,6 +572,9 @@
         db->databaseShort = get_entry_info( db, DICT_SHORT_ENTRY_NAME );
      else if (*db->databaseShort == '@')
         db->databaseShort = get_entry_info( db, db->databaseShort + 1 );
  +   else 
  +      db->databaseShort = xstrdup (db->databaseShort); 
  + 
      if (!db->databaseShort)
         db->databaseShort = xstrdup (db->databaseName);

----------------------------------------------------------------------
Version 1.9.4, by Aleksey Cheusov, 20 Feb 2003 17:01:30 +0200

  dict-1.9.4 is released.
  It is available for download from
  http://sourceforge.net/projects/dict


  Major changes:

  - Documentation update by Bob Hilliard

  - 'snprintf' and 'vsnprintf' functions are used instead of
  'sprintf' and 'vsprintf' on platforms where they are available.

  - dictd fails if it is run with "C" locale
  and discovers 8-bit/utf-8 dictionaries.

  dictfmt/dictfmt_index2suffix/dictfmt_index2word/dictfmt_virtual fails
  if they are run with "C" locale
  and discover 8-bit/utf-8 input.

  - 'make samples' bug fixed
  - 'dict --serverinfo' bug fixed
  - 'dictd --test-match' bug fixed

----------------------------------------------------------------------
Version 1.9.3, by Aleksey Cheusov, 24 Jan 2003 12:53:48 +0200

  dictd-1.9.3 has been released.
  It is available for download from http://sourceforge.net/projects/dict

  Major changes:
    - fix for dictd.
      It crashes on exiting/reloading configuration file
      if access section in the configuration file is empty.
      Affected versions: 1.8.0, 1.9.1, 1.9.2

----------------------------------------------------------------------
Version 1.9.2, by Aleksey Cheusov, 16 Jan 2003 15:42:29 +0200

  dictd-1.9.2 has been released
  It is available from http://sourceforge.net/projects/dict


  Major changes:
  - fix for dictzip's segfault
  - dictunformat utility
  - additional  dictfmt arguments:
    --without-header
    --without-url
    --without-time
  - error message is returned by 'dictd' for invalid utf-8 requests
    IMHO it is better than return code 501 specified by RFC
  - DESTDIR env. variable is used for installing/uninstalling
    This simplifies building RPMs.

----------------------------------------------------------------------
Version 1.9.1, by Aleksey Cheusov, 17 Dec 2002 17:32:40 +0200

  dictd-1.9.1 is available for download
  from http://sourceforge.net/projects/dict/

  Major changes:
  - Virtual dictionaries support
  - New search strategy 'word'
  - Configuration file reloading by SIGHUP
  - A lot of plugin enhancements and two plugin examples.
     You can also disable plugin support explicitly by running
     ./configure --disable-plugin
  - bugs fixing

----------------------------------------------------------------------
Version 1.8.0, by Aleksey Cheusov, 15 Sep 2002 20:54:30 -0400

  - better 8bit, UTF-8, and i18n support
  - dictfmt is now part of the dictd tarball
  - dictd supports plugins
  - dictd will use system libz when possible

----------------------------------------------------------------------
Version 1.7.1
  (broken support for 8bit dictionaries)

----------------------------------------------------------------------
Version 1.7.0, by Rick Faith, 3 May 2002 10:02:11 -0400

  I've released dictd 1.7.0.  It's the same as 1.6.93, except:
     1) The locale for dictd defaults to "C".  So if you've been using
        LC_ALL, you probably need to use the new --locale option.  I know
        this is a kludge and that dictd must move to Unicode/UTF-8/UCS-4.
     2) The dict pager is closed on fatal errors.  This may help prevent
        the screen corruption under Debian when dict is used with less
        and there is a fatal error.  Please let me know.
        3) Log output no longer filters the 8th bit.

  I've also updated the databases on www.dict.org to the most recent ones
  in use by Debian, and I've put those in ftp.dict.org:/pub/dict/pre.  I'm
  still using web1913 and wn instead of gcide.  However, gcide is
  available for testing if you use "dict -ugcide -kgcide -dgcide" [this
  may be removed in the future, but try it out now; note that older client
  may not pass authenticate unless you also specify -h].  Please don't
  hard code a "user gcide gcide" in any example or distributed .dictrc
  files.  Thanks.

----------------------------------------------------------------------
Version 1.6.93-testonly, by Rick Faith
  (no information available)

----------------------------------------------------------------------
Version 1.5.5, by Rick Faith
  (no information available)

----------------------------------------------------------------------
Version 1.5.3, by Rick Faith
  (no information available)

----------------------------------------------------------------------
Version 1.5.0, by Rick Faith, 22 Dec 1999 10:43:37 -0500

  dictd-1.5.0 has been released.  This is a bug fix release that should cover 
  most of the common problems that have been reported.  Testing on
  Sparc/Linux still needs to be done.  The IRIX port is not useful.

  This files contains the sources to the dict client, the dictd server, and
  the dictzip compression program.  Starting with version 2.0.0, sources to
  these programs will be in different files.

  Sources are available from:

  ftp://ftp.dict.org/pub/dict/dictd-1.5.0.tar.gz

  and from the SourceForge repository, via http:

  http://www.sourceforge.net/project/?form_grp=605

  or via anonymous cvs (see the appropriate link on the page above).

  We have moved the core software development effort to SourceForge, since it 
  provides a publicly accessible cvs repository and bug tracking.  Feel free
*  to submit bugs via the SourceForge interface or via dict-beta@dict.org.

----------------------------------------------------------------------
Version 1.4.9, by Rick Faith
  (no information available)

----------------------------------------------------------------------
Version 1.4.8, by Rick Faith
  (no information available)

----------------------------------------------------------------------
Version 1.4.5, by Rick Faith, 23 Feb 1998 20:00:23 -0500

  The DICT Development Group (www.dict.org) announces the dictd-1.4.x
  distribution, containing client/server software implementing the
  Dictionary Server Protocol, as described in RFC 2229.

  The Dictionary Server Protocol (DICT) is a TCP transaction based
  query/response protocol that allows a client to access dictionary
  definitions from a set of natural language dictionary databases.

  dict(1) is a client which can access DICT servers from the command line.

  dictd(8) is a server which supports the DICT protocol.

  dictzip(1) is a compression program which creates compressed files in the
  gzip format (see RFC 1952).  However, unlike gzip(1), dictzip(1) compresses
  the file in pieces and stores an index to the pieces in the gzip header.
  This allows random access to the file at the granularity of the compressed
  pieces (currently about 64kB) while maintaining good compression ratios
  (within 5% of the expected ratio for dictionary data).  dictd(8) uses files
  stored in this format.

----------------------------------------------------------------------
Version 1.4.3, by Rick Faith
  (no information available)

DICT protocol, by Rick Faith, 29 Oct 1997 19:34:58 -0500

  A new Request for Comments is now available in online RFC libraries.

  RFC 2229:

  Title:      A Dictionary Server Protocol
  Author(s):  R. Faith, B. Martin
  Status:     Informational
  Date:       October 1997
  Mailbox:    faith@cs.unc.edu, bamartin@miranda.org
  Pages:      30
  Characters: 59551
  Updates/Obsoletes:    None

  URL:        ftp://ds.internic.net/rfc/rfc2229.txt

 The Dictionary Server Protocol (DICT) is a TCP transaction based
 query/response protocol that allows a client to access dictionary
 definitions from a set of natural language dictionary databases.

 This memo provides information for the Internet community.  It does
 not specify an Internet standard of any kind.  Distribution of this
 memo is unlimited.
